**** Include file for TI-85 programs converted with Source Guru

        XDEF    _main
        XDEF    _comment

        XDEF    _ti92plus
        XDEF    _ti89

_main:
_ti92plus:
_ti89:
        lea     _comment-$2000,a6   ; A6 -> start of program
        lea     -8192(sp),sp
        lea     (sp),a4             ; A4 -> 8K buffer
        move.l  a4,buffer

    IFNE    EXACT_STACK
        move.l  #___byebye-_comment+$9000,d7
    ENDIF
    IFEQ    EXACT_STACK
        moveq   #0,d7
    ENDIF

        jsr     ti85lib2@0000
        lea     8192(sp),sp
        rts
buffer: dc.l    0
_comment:

**** Macro to define a label; sets both Z80 and real addresses

__LABEL MACRO
RA_\1   equ     *
\1      equ     RA_\1-_comment+$9000
        ENDM

**** Macro to calculate address Dn into An; run-time address resolution

__ADDR  MACRO

    IFNE    \1-1
        move.w  d\1,d1
    ENDIF

        sub.w   #$7000,d1
        bclr    #15,d1
        cmp.w   #$2000,d1
        blt.s   ib\@

        lea     _comment-$2000(pc),a\1
        bra.s   ip\@

ib\@:          
        move.l  a0,a\1

ip\@:
        add.w   d1,a\1
        ENDM

**** Macro to define a constant word (DW directive)

__DW    MACRO
        dc.b    (\1)&$FF
        dc.b    ((\1)&$FF00)>>8
        ENDM

**** Macro to implement LDIR instruction

__LDIR  MACRO
        jsr     ti85lib2@0016
        ENDM

**** Macro to implement LDDR instruction

__LDDR  MACRO
        jsr     ti85lib2@0017
        ENDM


**** Macro to implement LD A,R instruction

__RAND  MACRO
        jsr     ti85lib2@000D
        ENDM

**** Macro to implement INC SP instruction

__INCSTACK  MACRO
        bchg    #31,d6
        bne.s   ni\@
        addq.w  #2,a7
ni\@:
        ENDM

**** Macro to implement DEC SP instruction

__DECSTACK  MACRO
        bchg    #31,d6
        beq.s   nd\@
        subq.w  #2,a7
nd\@:
        ENDM

**** Macro to implement stack-exact calls

__JSR   MACRO
        move.w  #ra\@-_comment+$9000,-(sp)
        bra      \1
ra\@:
        ENDM

**** Macro to implement stack-exact returns

__RTS   MACRO
        move.w  (sp)+,d0
        lea     _comment+$7000(pc),a6
        jmp     0(a6,d0.w)
        ENDM
